
//
// Copyright (C) 2019, Order Flow Analytics Inc <www.orderflowanalytics.com>.
// OFA reserves the right to modify or overwrite this NinjaScript component with each release.
//
// By installing, using in whole or in part any sample code from Order Flow Analytics you agree to fully indemnify and hold harmless OrderFlowAnalytics, Inc 
// and its affiliates from and against any claims, losses, liabilities and expenses that may be incurred 
// as a result having downloaded and/or used any or all of the available code.
// Do thoroughly test any code & modifications for indicators and strategies in Replay Test mode

#region Using declarations
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;
using System.Windows.Media;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Gui;
using NinjaTrader.Gui.Chart;
using NinjaTrader.Gui.SuperDom;
using NinjaTrader.Gui.Tools; 
using NinjaTrader.Data;
using NinjaTrader.NinjaScript;
using NinjaTrader.Core.FloatingPoint;
using NinjaTrader.NinjaScript.DrawingTools;
using NinjaTrader.OFA;
#endregion

//This namespace holds Indicators in this folder and is required. Do not change it. 
namespace NinjaTrader.NinjaScript.Indicators
{
	public class OFASampleCalcCumDelta : Indicator 
	{
		private OFAIndicatorSTCORE OFAIndicatorSTCORE1;
	
		//private Series<double>	POCCalculation;    // Data series to store any calculation on the OFA data.
		
		protected override void OnStateChange()
		{
			if (State == State.SetDefaults)
			{
				Description									= @"Enter the description for your new custom Indicator here.";
				Name										= "OFASampleCalcCumDelta";
				Calculate									= Calculate.OnBarClose;
				IsOverlay									= false;
				DisplayInDataBox							= true;
				DrawOnPricePanel							= false;
				DrawHorizontalGridLines						= false;
				DrawVerticalGridLines						= false;
				PaintPriceMarkers							= true;
				ScaleJustification							= NinjaTrader.Gui.Chart.ScaleJustification.Right;
				//Disable this property if your indicator requires custom values that cumulate with each new market data event. 
				//See Help Guide for additional information.
				IsSuspendedWhileInactive					= false;
				//Ma = 5;
				AddPlot(Brushes.Cyan, "CDline");
			}
			else if (State == State.Configure)
			{
				
				//POCCalculation = new Series<double>(this);
			}
			
			else if (State == State.DataLoaded)
			{				
				
				OFAIndicatorSTCORE1				= OFAIndicatorSTCORE(Close, 30, 70, NinjaTrader.OFA.OFAColorLogic.POC);
				
			}
		}

		protected override void OnBarUpdate()
		{
			//Add your custom indicator logic here
//			if (BarsInProgress != 0) 
//				return;  

			if (CurrentBars[0] < 1)
				return;
			
			// Option if user wants to do any calculation on the POC price ...
			// commented out for now ..
			
			// POCCalculation[0] = OFAIndicatorSTCORE1.OFAPocPrice[0];
			
			if (Bars.IsFirstBarOfSession)
			{
              CDline[0] = 0;                   
			
			  CDline[0] = OFAIndicatorSTCORE1.OFABarDeltaVolume[0];
			}
			else
			{
			  CDline[0] = CDline[1] + OFAIndicatorSTCORE1.OFABarDeltaVolume[0];
			}
			
		}

		#region Properties

		[Browsable(false)]
		[XmlIgnore]
		public Series<double> CDline
		{
			get { return Values[0]; }
		}
		
//		[NinjaScriptProperty]
//		[Range(1, int.MaxValue)]
//		[Display(Name="Ma", Order=1, GroupName="Parameters")]
//		public int Ma
//		{ get; set; }
		
		#endregion
		

	}
}

#region NinjaScript generated code. Neither change nor remove.

namespace NinjaTrader.NinjaScript.Indicators
{
	public partial class Indicator : NinjaTrader.Gui.NinjaScript.IndicatorRenderBase
	{
		private OFASampleCalcCumDelta[] cacheOFASampleCalcCumDelta;
		public OFASampleCalcCumDelta OFASampleCalcCumDelta()
		{
			return OFASampleCalcCumDelta(Input);
		}

		public OFASampleCalcCumDelta OFASampleCalcCumDelta(ISeries<double> input)
		{
			if (cacheOFASampleCalcCumDelta != null)
				for (int idx = 0; idx < cacheOFASampleCalcCumDelta.Length; idx++)
					if (cacheOFASampleCalcCumDelta[idx] != null &&  cacheOFASampleCalcCumDelta[idx].EqualsInput(input))
						return cacheOFASampleCalcCumDelta[idx];
			return CacheIndicator<OFASampleCalcCumDelta>(new OFASampleCalcCumDelta(), input, ref cacheOFASampleCalcCumDelta);
		}
	}
}

namespace NinjaTrader.NinjaScript.MarketAnalyzerColumns
{
	public partial class MarketAnalyzerColumn : MarketAnalyzerColumnBase
	{
		public Indicators.OFASampleCalcCumDelta OFASampleCalcCumDelta()
		{
			return indicator.OFASampleCalcCumDelta(Input);
		}

		public Indicators.OFASampleCalcCumDelta OFASampleCalcCumDelta(ISeries<double> input )
		{
			return indicator.OFASampleCalcCumDelta(input);
		}
	}
}

namespace NinjaTrader.NinjaScript.Strategies
{
	public partial class Strategy : NinjaTrader.Gui.NinjaScript.StrategyRenderBase
	{
		public Indicators.OFASampleCalcCumDelta OFASampleCalcCumDelta()
		{
			return indicator.OFASampleCalcCumDelta(Input);
		}

		public Indicators.OFASampleCalcCumDelta OFASampleCalcCumDelta(ISeries<double> input )
		{
			return indicator.OFASampleCalcCumDelta(input);
		}
	}
}

#endregion
